/***************************************************************************
                          config.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIG_H
#define CONFIG_H

#include "global_types.h"
/**
  *@author funthing (Matthias Zisler)
  */
class CL_String;

class Config
{
public:
	static bool get_music();
	static void set_music(bool m);
	static bool get_fps();
	static void set_fps(bool f);
	static int get_music_vol();
	static void set_music_vol(int v);
	static bool get_intro();
	static void set_intro(bool i);
	static bool get_full_screen();
	static void set_full_screen(bool f);
	static int get_skill();
	static void set_skill(int s);
	static int get_speed();
	static void set_speed(int s);

	static void read_maxl();
	static int get_maxl();
	static int get_last_level();
	static void set_last_level(int l);
	static CL_String get_last_levelset();
	static void set_last_levelset(CL_String l);
	static void next_map();
	static void prev_map();
	static int keys[18];

	static void init();
	static void deinit();
	static void reset();

private:

	static unsigned int ms;
	static vector <CL_String> map_samples;
	static int music;
	static int intro;
	static int full_screen;
	static int music_vol;
	static int skill;
	static int speed;
	static CL_String last_levelset;
	static int last_level;
	static CL_String filename;
	static int fps;
	static int maxl;
};


#endif
