/***************************************************************************
                          game.h  -  description
                             -------------------
    begin                : Tue Feb 12 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAME_H
#define GAME_H
#include "global_types.h"

/**
  *@author funthing (Matthias Zisler)
  */

class Auriferous;
class Sprite;
class Player;
class Button;
class Map_Sample;
class Timer;

class Game
{
public: 
	Game(Auriferous* _app);
	~Game();

	void run(bool players);
	bool get_t();

	Map_Sample* sample;

private:

	void draw_game_gui();
	void draw_hud();
	void show_dialog();
	void act_game();
	void show_game();
	void play_outro();

	Button* yes;
	Button* no;

	bool must_end, showmen, t;
	Auriferous* app;
	
	/* For framerate throttling */
	Timer *timer;
};

#endif
