/***************************************************************************
                          maptile.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "maptile.h"
#include "game.h"
#include "map.h"
#include "map_sample.h"
#include "resources.h"

Maptile::Maptile(int _x, int _y, WorldType _wt, Map* _map)
{
	x=_x;
	y=_y;
	spr=0;
	blocking=false;
	wt=_wt;
	mt=EMPTY;
	map=_map;
	map->tiles.push_back(this);
	delme=false;
	digged=0;

	switch(wt)
	{
	  case AQUA: sur=Resources::Atile();	break;
	  case ICE: sur=Resources::Itile();	break;
	  case LAVA: sur=Resources::Ltile();	break;
	  case JUNGLE: sur=Resources::Jtile();	break;
	  case TECH: sur=Resources::Ttile();	break;
	}

}
Maptile::~Maptile()
{
}
MaptileType Maptile::get_type()
{
	return mt;
}
int Maptile::get_x()
{
	return x;
}
int Maptile::get_y()
{
	return y;
}
void Maptile::set_blocking(bool b)
{
	blocking=b;
}
bool Maptile::is_blocking()
{
	return blocking;
}
bool Maptile::is_fallt()
{
	return fallt;
}
void Maptile::fit()
{
	if((mt==NORMAL || mt==ONCE) && map->get_up(this)->get_type()==EMPTY)
	{
		spr=8;
	
		if(map->get_down(this)->get_type()==EMPTY)
		{
			spr=9;

			if(map->get_right(this)->get_type()==EMPTY && map->get_left(this)->get_type()==EMPTY)
			spr=11;
			else if(map->get_left(this)->get_type()==EMPTY)
			spr=12;
			else if(map->get_right(this)->get_type()==EMPTY)
			spr=13;
		}
		else
		{
			if(map->get_right(this)->get_type()==EMPTY && map->get_left(this)->get_type()==EMPTY)
			spr=10;
			else if(map->get_left(this)->get_type()==EMPTY)
			spr=14;
			else if(map->get_right(this)->get_type()==EMPTY)
			spr=15;
		}
	}
	else if(mt==NORMAL || mt==SLIME || mt==CONCRETE || mt==MOVE)
	{
		int offset=0;
	
		if(mt==SLIME)
		offset=48;
		else if(mt==CONCRETE || mt==MOVE)
		offset=40;

		spr=0+offset;

		if(map->get_down(this)->get_type()==EMPTY)
		{
			spr=1+offset;

			if(map->get_right(this)->get_type()==EMPTY && map->get_left(this)->get_type()==EMPTY)
			spr=3+offset;
			else if(map->get_left(this)->get_type()==EMPTY)
			spr=4+offset;
			else if(map->get_right(this)->get_type()==EMPTY)
			spr=5+offset;
		}
		else
		{
			if(map->get_right(this)->get_type()==EMPTY && map->get_left(this)->get_type()==EMPTY)
			spr=2+offset;
			else if(map->get_left(this)->get_type()==EMPTY)
			spr=6+offset;
			else if(map->get_right(this)->get_type()==EMPTY)
			spr=7+offset;
		}
	}

	if(mt==HIDEOUT)
	{
		if(map->get_up(this)->get_type()==EMPTY)
		{
			if(map->get_right(this)->get_type()==EMPTY && map->get_left(this)->get_type()==EMPTY)
			spr=61;
			else if(map->get_left(this)->get_type()==EMPTY)
			spr=62;
			else if(map->get_right(this)->get_type()==EMPTY)
			spr=63;
			else
			spr=60;
		}
		else
		{
			if(map->get_right(this)->get_type()==EMPTY && map->get_left(this)->get_type()==EMPTY)
			spr=57;
			else if(map->get_left(this)->get_type()==EMPTY)
			spr=58;
			else if(map->get_right(this)->get_type()==EMPTY)
			spr=59;
			else
			spr=56;
		}
	}
}
bool Maptile::delete_me()
{
	return delme;
}
void Maptile::set_delme()
{
	if(mt!=DUMMY)
	delme=true;
}
bool Maptile::get_digged()
{
	return digged;
}