/***************************************************************************
                          submenu.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUBMENU_H
#define SUBMENU_H

#include "menu.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Auriferous;
class Button;
class Wheel;
class Arrow;
class Checker;
class CL_InputBuffer;
class Timer;

class Submenu
{
public: 
	Submenu(Auriferous* _app);
	~Submenu();
	void new_sub(SubType st);
	bool active();
	void start_new_game();
	void act();
	void clean();
	void wait_key();
	CL_String key_name(int k);

private:

	Button* back;
	Button* save;
	Button* reset;
	vector<Button*> keys;
	CL_String s_keys[18];
	int i_keys[18];
	Button* start_game;
	Checker* music;
	Checker* full_screen;
	Checker* intro;
	Checker* fps;
	Wheel* m_vol;
	Wheel* skill;
	Wheel* speed;
	Arrow* a_up;
	Arrow* a_down;
	bool activ, wait, old_m;
	int key, old_vol;
	Auriferous* app;
	SubType stype;
	CL_String level;
	Timer* timer;
	CL_InputBuffer* key_buffer;
};

#endif
