/***************************************************************************
                          wheel.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "wheel.h"
#include "arrow.h"

Wheel::Wheel(int _x, int _y, Menu* _men, int _max, int _val) : Gui(_x, _y, _men)
{
	type=WHEEL;
	up=new Arrow(x, y-32, _men, UP);
	down=new Arrow(x, y, _men, DOWN);
	font=Resources::Rfontg();
	val=_val;
	max=_max;
}
Wheel::~Wheel()
{
}
void Wheel::set_val(int i)
{
	val=i;
}
void Wheel::set_max(int i)
{
	max=i;
}
int Wheel::get_val()
{
	return val;
}
void Wheel::act()
{
	if(up->is_clicked()==true)
		if(val<max)
		val++;

	if(down->is_clicked()==true)
		if(val>1)
		val--;

	font->print_left(x+32, y-10, (CL_String)(val));
}
void Wheel::set_Delete_Me()
{
	up->set_Delete_Me();
	down->set_Delete_Me();
	delete_me=true;
}